Add yet another expression test and fix the bugs it found.
authorBen Pfaff <blp@gnu.org>
Mon, 7 Mar 2005 03:34:47 +0000 (03:34 +0000)
committerBen Pfaff <blp@gnu.org>
Mon, 7 Mar 2005 03:34:47 +0000 (03:34 +0000)
src/expressions/ChangeLog
src/expressions/TODO
src/expressions/operations.def
src/expressions/parse.c
tests/ChangeLog
tests/Makefile.am
tests/expressions/vectors.sh [new file with mode: 0755]

index 94063e7acff932707325824c90c03b1bd3ca94f4..9de71dafe8c4c3b9c5bb83425b39952ecf7095fa 100644 (file)
@@ -1,3 +1,11 @@
+Sun Mar  6 19:33:24 2005  Ben Pfaff  <blp@gnu.org>
+
+       * operations.def: (VEC_ELEM_NUM) Treat user-missing values as
+       system-missing.
+
+       * parse.c: (parse_vector_element) Fix order of arguments in call
+       to expr_allocate_binary().
+
 Sun Mar  6 17:51:05 2005  Ben Pfaff  <blp@gnu.org>
 
        * optimize.c: (optimize_tree) Fix optimization bug for x**2.
index ba378e8c473cc2299b02bf2ef8bded78e1397e36..2bcbb8c6522f30f741dc4758801f4e622036d8a6 100644 (file)
@@ -1,7 +1,5 @@
 Needed:
 
-    - Must test vectors on expressions.
-
     - Warnings on domain errors (see "Domain Errors" in SPSS manual)
       and documentation of such.
 
index 8338e18fb909792ee582086d95bd96e0b582a7ac..8165b740890d134748491c5cf5c12f537212d299 100644 (file)
@@ -888,8 +888,12 @@ no_opt operator VEC_ELEM_NUM (idx)
      vector v;
      case c;
 {
-  if (idx >= 1 && idx <= v->cnt)
-    return case_num (c, v->var[(int) idx - 1]->fv);
+  if (idx >= 1 && idx <= v->cnt) 
+    {
+      const struct variable *var = v->var[(int) idx - 1];
+      double value = case_num (c, var->fv);
+      return !is_num_user_missing (value, var) ? value : SYSMIS; 
+    }
   else
     {
       if (idx == SYSMIS)
index 5e917a0e80386e65b936078ebe6090175b7dfb7f..be0b9d7973dadb207c6e3fb6a3cc4bcf03ee238b 100644 (file)
@@ -863,7 +863,7 @@ parse_vector_element (struct expression *e)
 
   return expr_allocate_binary (e, (vector->var[0]->type == NUMERIC
                                    ? OP_VEC_ELEM_NUM : OP_VEC_ELEM_STR),
-                               expr_allocate_vector (e, vector), element);
+                               element, expr_allocate_vector (e, vector));
 }
 \f
 /* Individual function parsing. */
index 3e97048a86a2f84f766f06c1a8ca69ba29ff3adc..0a8ef20b71bf457e4c6ae7b92fc7281cf5a0ca45 100644 (file)
@@ -1,3 +1,9 @@
+Sun Mar  6 19:30:14 2005  Ben Pfaff  <blp@gnu.org>
+
+       * expressions/vectors.sh: New test.
+
+       * Makefile.am: Add expressions/vectors.sh.
+
 Sun Mar  6 17:56:27 2005  Ben Pfaff  <blp@gnu.org>
 
        * expressions/expressions.sh: Add tests for generic optimizations.
index 5ee230c3e8bc42787e0d911726d6b0289d74256b..62b806090d5dfdc31a442df9d148971e00a97d3d 100644 (file)
@@ -81,7 +81,8 @@ TESTS = \
        expressions/expressions.sh \
        expressions/epoch.sh \
        expressions/randist.sh \
-       expressions/variables.sh
+       expressions/variables.sh \
+       expressions/vectors.sh
 
 noinst_PROGRAMS = gengarbage
 
diff --git a/tests/expressions/vectors.sh b/tests/expressions/vectors.sh
new file mode 100755 (executable)
index 0000000..604920e
--- /dev/null
@@ -0,0 +1,99 @@
+#!/bin/sh
+
+# This program tests use of vectors in expressions.
+
+TEMPDIR=/tmp/pspp-tst-$$
+
+here=`pwd`;
+
+# ensure that top_srcdir is absolute
+cd $top_srcdir; top_srcdir=`pwd`
+
+export STAT_CONFIG_PATH=$top_srcdir/config
+
+
+cleanup()
+{
+     rm -rf $TEMPDIR
+}
+
+
+fail()
+{
+    echo $activity
+    echo FAILED
+    cleanup;
+    exit 1;
+}
+
+
+no_result()
+{
+    echo $activity
+    echo NO RESULT;
+    cleanup;
+    exit 2;
+}
+
+pass()
+{
+    cleanup;
+    exit 0;
+}
+
+mkdir -p $TEMPDIR
+
+cd $TEMPDIR
+
+activity="create program"
+cat > $TEMPDIR/vectors.stat <<EOF
+DATA LIST /N1 TO N5 1-5.
+MISSING VALUES N1 TO N5 (3 THRU 5, 1).
+BEGIN DATA.
+12345
+6789 
+END DATA.
+
+VECTOR N=N1 TO N5.
+VECTOR X(5).
+LOOP I=1 TO 5.
+COMPUTE X(I)=N(I) + 1.
+END LOOP.
+
+FORMATS ALL (F2).
+
+LIST.
+EOF
+if [ $? -ne 0 ] ; then no_result ; fi
+
+activity="run program"
+$SUPERVISOR $here/../src/pspp -o raw-ascii $TEMPDIR/vectors.stat > $TEMPDIR/vectors.err 2> $TEMPDIR/vectors.out
+if [ $? -ne 0 ] ; then fail ; fi
+
+activity="compare results"
+diff -b -B $TEMPDIR/pspp.list - <<EOF
+1.1 DATA LIST.  Reading 1 record from the command file.
++--------+------+-------+------+
+|Variable|Record|Columns|Format|
+#========#======#=======#======#
+|N1      |     1|  1-  1|F1.0  |
+|N2      |     1|  2-  2|F1.0  |
+|N3      |     1|  3-  3|F1.0  |
+|N4      |     1|  4-  4|F1.0  |
+|N5      |     1|  5-  5|F1.0  |
++--------+------+-------+------+
+
+N1 N2 N3 N4 N5 X1 X2 X3 X4 X5  I
+-- -- -- -- -- -- -- -- -- -- --
+ 1  2  3  4  5  .  3  .  .  .  5 
+ 6  7  8  9  .  7  8  9 10  .  5 
+EOF
+
+if [ $? -ne 0 ] ; then no_result ; fi
+
+
+if [ $? -ne 0 ] ; then fail ; fi
+
+
+
+pass;